Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCode.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCode.cs	(revision 14320)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/OpCode.cs	(revision 14328)
@@ -18,5 +18,5 @@
         /// <summary>
         /// BOOLEAN.DEFINE:
-        /// Defines the name on top of the NAME stack as an instruction that will push the top item of the BOOLEAN stack onto the EXEC stack.
+        /// Defines the name on top of the NAME stack as an inclassion that will push the top item of the BOOLEAN stack onto the EXEC stack.
         /// </summary>
         BooleanDefine,
@@ -24,7 +24,7 @@
         /// <summary>
         /// BOOLEAN.DUP:
-        /// Duplicates the top item on the BOOLEAN stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!)
-        /// </summary>
-        BooleanDup,
+        /// Duplicatelicates the top item on the BOOLEAN stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!)
+        /// </summary>
+        BooleanDuplicate,
 
         /// <summary>
@@ -109,5 +109,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        BooleanYankDup,
+        BooleanYankDuplicate,
         #endregion Boolean
 
@@ -123,5 +123,5 @@
         /// <summary>
         /// CODE.APPEND:
-        /// Pushes the result of appending the top two pieces of code. If one of the pieces of code is a single instruction or literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
+        /// Pushes the result of appending the top two pieces of code. If one of the pieces of code is a single inclassion or literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
         /// </summary>
         CodeAppend,
@@ -129,5 +129,5 @@
         /// <summary>
         /// CODE.ATOM:
-        /// Pushes TRUE onto the BOOLEAN stack if the top piece of code is a single instruction or a literal, and FALSE otherwise (that is, if it is something surrounded by parentheses).
+        /// Pushes TRUE onto the BOOLEAN stack if the top piece of code is a single inclassion or a literal, and FALSE otherwise (that is, if it is something surrounded by parentheses).
         /// </summary>
         CodeAtom,
@@ -165,5 +165,5 @@
         /// <summary>
         /// CODE.DEFINE:
-        /// Defines the name on top of the NAME stack as an instruction that will push the top item of the CODE stack onto the EXEC stack.
+        /// Defines the name on top of the NAME stack as an inclassion that will push the top item of the CODE stack onto the EXEC stack.
         /// </summary>
         CodeDefine,
@@ -171,5 +171,5 @@
         /// <summary>
         /// CODE.DEFINITION:
-        /// Pushes the definition associated with the top NAME on the NAME stack (if any) onto the CODE stack. This extracts the definition for inspection/manipulation, rather than for immediate execution (although it may then be executed with a call to CODE.DO or a similar instruction).
+        /// Pushes the definition associated with the top NAME on the NAME stack (if any) onto the CODE stack. This extracts the definition for inspection/manipulation, rather than for immediate execution (although it may then be executed with a call to CODE.DO or a similar inclassion).
         /// </summary>
         CodeDefinition,
@@ -178,5 +178,5 @@
         /// CODE.DESCREPANCY:
         /// Pushes a measure of the discrepancy between the top two CODE stack items onto the INTEGER stack. This will be zero if the top two items are equivalent, and will be higher the 'more different' the items are from one another. The calculation is as follows:
-        /// 1. Construct a list of all of the unique items in both of the lists (where uniqueness is determined by equalp). Sub-lists and atoms all count as items.
+        /// 1. Conclass a list of all of the unique items in both of the lists (where uniqueness is determined by equalp). Sub-lists and atoms all count as items.
         /// 2. Initialize the result to zero.
         /// 3. For each unique item increment the result by the difference between the number of occurrences of the item in the two pieces of code.
@@ -199,5 +199,5 @@
         /// <summary>
         /// CODE.DO*COUNT:
-        /// An iteration instruction that performs a loop (the body of which is taken from the CODE stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body. This should be implemented as a macro that expands into a call to CODE.DO*RANGE. CODE.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single CODE argument (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
+        /// An iteration inclassion that performs a loop (the body of which is taken from the CODE stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body. This should be implemented as a macro that expands into a call to CODE.DO*RANGE. CODE.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single CODE argument (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
         /// ( 0 '1 - IntegerArg' CODE.QUOTE <CodeArg> CODE.DO*RANGE )
         /// </summary>
@@ -206,5 +206,5 @@
         /// <summary>
         /// CODE.DO*RANGE:
-        /// An iteration instruction that executes the top item on the CODE stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop. The top integer is the "destination index" and the second integer is the "current index." First the code and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC stack -- first a recursive call to CODE.DO*RANGE (with the same code and destination index, but with a current index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a destination index that is less than the specified current index.
+        /// An iteration inclassion that executes the top item on the CODE stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop. The top integer is the "destination index" and the second integer is the "current index." First the code and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC stack -- first a recursive call to CODE.DO*RANGE (with the same code and destination index, but with a current index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a destination index that is less than the specified current index.
         /// </summary>
         CodeDoXRange,
@@ -218,11 +218,11 @@
         /// <summary>
         /// CODE.DUP:
-        /// Duplicates the top item on the CODE stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
-        /// </summary>
-        CodeDup,
+        /// Duplicatelicates the top item on the CODE stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
+        /// </summary>
+        CodeDuplicate,
 
         /// <summary>
         /// CODE.EXTRACT:
-        /// Pushes the sub-expression of the top item of the CODE stack that is indexed by the top item of the INTEGER stack. The indexing here counts "points," where each parenthesized expression and each literal/instruction is considered a point, and it proceeds in depth first order. The entire piece of code is at index 0; if it is a list then the first item in the list is at index 1, etc. The integer used as the index is taken modulo the number of points in the overall expression (and its absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
+        /// Pushes the sub-expression of the top item of the CODE stack that is indexed by the top item of the INTEGER stack. The indexing here counts "points," where each parenthesized expression and each literal/inclassion is considered a point, and it proceeds in depth first order. The entire piece of code is at index 0; if it is a list then the first item in the list is at index 1, etc. The integer used as the index is taken modulo the number of points in the overall expression (and its absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
         /// </summary>
         CodeExtract,
@@ -265,4 +265,10 @@
 
         /// <summary>
+        /// CODE.INSTRUCTIONS:
+        /// Pushes a list of all active instructions in the interpreter's current configuration.
+        /// </summary>
+        CodeInstructions,
+
+        /// <summary>
         /// CODE.INSERT:
         /// Pushes the result of inserting the second item of the CODE stack into the first item, at the position indexed by the top item of the INTEGER stack (and replacing whatever was there formerly). The indexing is computed as in CODE.EXTRACT.
@@ -272,7 +278,7 @@
         /// <summary>
         /// CODE.INSTRUCTIONS:
-        /// Pushes a list of all active instructions in the interpreter's current configuration.
-        /// </summary>
-        CodeInstructions,
+        /// Pushes a list of all active inclassions in the interpreter's current configuration.
+        /// </summary>
+        CodeInclassions,
 
         /// <summary>
@@ -311,4 +317,15 @@
 
         /// <summary>
+        /// CODE.NULL: Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise.
+        /// </summary>
+        CodeNull,
+
+        /// <summary>
+        /// CODE.POSITION:
+        /// Pushes onto the INTEGER stack the position of the second item on the CODE stack within the first item (which is coerced to a list if necessary). Pushes -1 if no match is found.
+        /// </summary>
+        CodePosition,
+
+        /// <summary>
         /// CODE.QUOTE:
         /// Specifies that the next expression submitted for execution will instead be pushed literally onto the CODE stack. This can be implemented by moving the top item on the EXEC stack onto the CODE stack.
@@ -334,5 +351,5 @@
 
         /// <summary>
-        /// CODE.SIZE: Pushes the number of "points" in the top piece of CODE onto the INTEGER stack. Each instruction, literal, and pair of parentheses counts as a point.
+        /// CODE.SIZE: Pushes the number of "points" in the top piece of CODE onto the INTEGER stack. Each inclassion, literal, and pair of parentheses counts as a point.
         /// </summary>
         CodeSize,
@@ -364,5 +381,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        CodeYankDup,
+        CodeYankDuplicate,
         #endregion Code
 
@@ -380,5 +397,5 @@
         /// <summary>
         /// EXEC.DEFINE:
-        /// Defines the name on top of the NAME stack as an instruction that will push the top item of the EXEC stack back onto the EXEC stack.
+        /// Defines the name on top of the NAME stack as an inclassion that will push the top item of the EXEC stack back onto the EXEC stack.
         /// </summary>
         ExecDefine,
@@ -386,5 +403,5 @@
         /// <summary>
         /// EXEC.DO*COUNT:
-        /// An iteration instruction that performs a loop (the body of which is taken from the EXEC stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body. This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. This should be implemented as a macro that expands into a call to EXEC.DO*RANGE. EXEC.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single EXEC argument (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
+        /// An iteration inclassion that performs a loop (the body of which is taken from the EXEC stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body. This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. This should be implemented as a macro that expands into a call to EXEC.DO*RANGE. EXEC.DO*COUNT takes a single INTEGER argument (the number of times that the loop will be executed) and a single EXEC argument (the body of the loop). If the provided INTEGER argument is negative or zero then this becomes a NOOP. Otherwise it expands into:
         /// ( 0 <1 - IntegerArg> EXEC.DO*RANGE <ExecArg> )
         /// </summary>
@@ -393,5 +410,5 @@
         /// <summary>
         /// EXEC.DO*RANGE:
-        /// An iteration instruction that executes the top item on the EXEC stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop. This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. The top integer is the "destination index" and the second integer is the "current index." First the code and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC stack -- first a recursive call to EXEC.DO*RANGE (with the same code and destination index, but with a current index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a destination index that is less than the specified current index.
+        /// An iteration inclassion that executes the top item on the EXEC stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop. This is similar to CODE.DO*COUNT except that it takes its code argument from the EXEC stack. The top integer is the "destination index" and the second integer is the "current index." First the code and the integer arguments are saved locally and popped. Then the integers are compared. If the integers are equal then the current index is pushed onto the INTEGER stack and the code (which is the "body" of the loop) is pushed onto the EXEC stack for subsequent execution. If the integers are not equal then the current index will still be pushed onto the INTEGER stack but two items will be pushed onto the EXEC stack -- first a recursive call to EXEC.DO*RANGE (with the same code and destination index, but with a current index that has been either incremented or decremented by 1 to be closer to the destination index) and then the body code. Note that the range is inclusive of both endpoints; a call with integer arguments 3 and 5 will cause its body to be executed 3 times, with the loop counter having the values 3, 4, and 5. Note also that one can specify a loop that "counts down" by providing a destination index that is less than the specified current index.
         /// </summary>
         ExecDoXRange,
@@ -405,11 +422,11 @@
         /// <summary>
         /// EXEC.DUP:
-        /// Duplicates the top item on the EXEC stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!). This may be thought of as a "DO TWICE" instruction.
-        /// </summary>
-        ExecDup,
+        /// Duplicatelicates the top item on the EXEC stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!). This may be thought of as a "DO TWICE" inclassion.
+        /// </summary>
+        ExecDuplicate,
 
         /// <summary>
         /// EXEC.FLUSH:
-        /// Empties the EXEC stack. This may be thought of as a "HALT" instruction.
+        /// Empties the EXEC stack. This may be thought of as a "HALT" inclassion.
         /// </summary>
         ExecFlush,
@@ -428,5 +445,5 @@
 
         /// <summary>
-        /// EXEC.POP: Pops the EXEC stack. This may be thought of as a "DONT" instruction.
+        /// EXEC.POP: Pops the EXEC stack. This may be thought of as a "DONT" inclassion.
         /// </summary>
         ExecPop,
@@ -439,6 +456,12 @@
 
         /// <summary>
+        /// EXEC.S:
+        /// The Push implementation of the "S combinator". Pops 3 items from the EXEC stack, which we will call A, B, and C (with A being the first one popped). Then pushes a list containing B and C back onto the EXEC stack, followed by another instance of C, followed by another instance of A.
+        /// </summary>
+        ExecS,
+
+        /// <summary>
         /// EXEC.SHOVE:
-        /// Inserts the top EXEC item "deep" in the stack, at the position indexed by the top INTEGER. This may be thought of as a "DO LATER" instruction.
+        /// Inserts the top EXEC item "deep" in the stack, at the position indexed by the top INTEGER. This may be thought of as a "DO LATER" inclassion.
         /// </summary>
         ExecShove,
@@ -464,5 +487,5 @@
         /// <summary>
         /// EXEC.YANK:
-        /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack. The index is taken from the INTEGER stack. This may be thought of as a "DO SOONER" instruction.
+        /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack. The index is taken from the INTEGER stack. This may be thought of as a "DO SOONER" inclassion.
         /// </summary>
         ExecYank,
@@ -472,5 +495,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        ExecYankDup,
+        ExecYankDuplicate,
         #endregion Exec
 
@@ -533,5 +556,5 @@
         /// <summary>
         /// FLOAT.DEFINE:
-        /// Defines the name on top of the NAME stack as an instruction that will push the top item of the FLOAT stack onto the EXEC stack.
+        /// Defines the name on top of the NAME stack as an inclassion that will push the top item of the FLOAT stack onto the EXEC stack.
         /// </summary>
         FloatDefine,
@@ -539,7 +562,7 @@
         /// <summary>
         /// FLOAT.DUP:
-        /// Duplicates the top item on the FLOAT stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
-        /// </summary>
-        FloatDup,
+        /// Duplicatelicates the top item on the FLOAT stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
+        /// </summary>
+        FloatDuplicate,
 
         /// <summary>
@@ -636,5 +659,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        FloatYankDup,
+        FloatYankDuplicate,
 
         #endregion Float
@@ -692,12 +715,6 @@
 
         /// <summary>
-        /// INTEGER.COS:
-        /// Pushes the cosine of the top item.
-        /// </summary>
-        IntegerCos,
-
-        /// <summary>
         /// INTEGER.DEFINE:
-        /// Defines the name on top of the NAME stack as an instruction that will push the top item of the INTEGER stack onto the EXEC stack.
+        /// Defines the name on top of the NAME stack as an inclassion that will push the top item of the INTEGER stack onto the EXEC stack.
         /// </summary>
         IntegerDefine,
@@ -705,7 +722,7 @@
         /// <summary>
         /// INTEGER.DUP:
-        /// Duplicates the top item on the INTEGER stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
-        /// </summary>
-        IntegerDup,
+        /// Duplicatelicates the top item on the INTEGER stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
+        /// </summary>
+        IntegerDuplicate,
 
         /// <summary>
@@ -769,10 +786,4 @@
 
         /// <summary>
-        /// INTEGER.SIN:
-        /// Pushes the sine of the top item.
-        /// </summary>
-        IntegerSin,
-
-        /// <summary>
         /// INTEGER.STACKDEPTH:
         /// Pushes the stack depth onto the INTEGER stack.
@@ -787,10 +798,4 @@
 
         /// <summary>
-        /// INTEGER.TAN:
-        /// Pushes the tangent of the top item.
-        /// </summary>
-        IntegerTan,
-
-        /// <summary>
         /// INTEGER.YANK:
         /// Removes an indexed item from "deep" in the stack and pushes it on top of the stack. The index is taken from the INTEGER stack.
@@ -802,5 +807,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        IntegerYankDup,
+        IntegerYankDuplicate,
 
         #endregion Integer
@@ -823,7 +828,7 @@
         /// <summary>
         /// NAME.DUP:
-        /// Duplicates the top item on the NAME stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
-        /// </summary>
-        NameDup,
+        /// Duplicatelicates the top item on the NAME stack. Does not pop its argument (which, if it did, would negate the effect of the duplication!).
+        /// </summary>
+        NameDuplicate,
 
         /// <summary>
@@ -890,5 +895,5 @@
         /// Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item. The index is taken from the INTEGER stack.
         /// </summary>
-        NameYankDup,
+        NameYankDuplicate,
         #endregion Name
     }