Index: branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/InputParameterView.cs
===================================================================
--- branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/InputParameterView.cs	(revision 14334)
+++ branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/InputParameterView.cs	(revision 14336)
@@ -92,5 +92,5 @@
     private void maxTextBox_TextChanged(object sender, EventArgs e) {
       double max;
-      if (double.TryParse(minTextBox.Text, out max))
+      if (double.TryParse(maxTextBox.Text, out max))
         Content.Max = max;
     }
@@ -98,5 +98,5 @@
     private void stepTextBox_TextChanged(object sender, EventArgs e) {
       double step;
-      if (double.TryParse(minTextBox.Text, out step))
+      if (double.TryParse(stepTextBox.Text, out step))
         Content.Step = step;
     }
@@ -104,5 +104,5 @@
     private void valueTextBox_TextChanged(object sender, EventArgs e) {
       double value;
-      if (double.TryParse(minTextBox.Text, out value))
+      if (double.TryParse(valueTextBox.Text, out value))
         Content.Value = value;
     }
Index: branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs
===================================================================
--- branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs	(revision 14334)
+++ branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs	(revision 14336)
@@ -90,5 +90,5 @@
       var goalMap = goals.ToDictionary(x => x.Name, x => x);
 
-      foreach (var variable in problemData.AllowedInputVariables) {
+      foreach (var variable in problemData.Dataset.DoubleVariables) {
         if (inputMap.ContainsKey(variable)) {
           var values = problemData.Dataset.GetReadOnlyDoubleValues(variable);
@@ -101,5 +101,5 @@
           }
           input.Min = min;
-          input.Min = max;
+          input.Max = max;
         } else if (goalMap.ContainsKey(variable)) {
           var values = problemData.Dataset.GetReadOnlyDoubleValues(variable);
Index: branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs
===================================================================
--- branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14334)
+++ branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/MultiObjectiveGoalSeekingProblem.cs	(revision 14336)
@@ -161,8 +161,4 @@
       SolutionCreatorParameter.Hidden = true;
       MaximizationParameter.Hidden = true;
-      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
-      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
-      dataset = new ModifiableDataset(Inputs.Select(x => x.Name), Inputs.Select(x => new List<double> { x.Value }));
-      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
       RegisterEvents();
     }
Index: branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs
===================================================================
--- branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs	(revision 14334)
+++ branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/Properties/AssemblyInfo.cs	(revision 14336)
@@ -54,3 +54,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.11.14325")]
+[assembly: AssemblyFileVersion("3.3.11.14334")]
Index: branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs
===================================================================
--- branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs	(revision 14334)
+++ branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/SingleObjectiveGoalSeekingProblem.cs	(revision 14336)
@@ -143,8 +143,4 @@
       EvaluatorParameter.Hidden = true;
       SolutionCreatorParameter.Hidden = true;
-      GoalSeekingUtil.UpdateInputs(InputsParameter.Value, Models, InputParameterChanged);
-      Encoding = GoalSeekingUtil.CreateEncoding(ActiveInputs);
-      dataset = new ModifiableDataset(Inputs.Select(x => x.Name), Inputs.Select(x => new List<double> { x.Value }));
-      GoalSeekingUtil.UpdateTargets(GoalsParameter.Value, Models, GoalParameterChanged);
       RegisterEvents();
     }